<?php
namespace Folha\Logic\ESocial;
use Folha\Entities\GpeEsocial;
use Folha\Entities\GpeEsocialEnvio;

/**
 * undocumented class
 *
 * @package default
 * @author 
 **/
class GerenciaEnvios
{
    private $nrEnvio;
    private $nrEsocial;
    private $dsEvento;
    private $versao;
    private $nrChave;
    private $dtMescompetenc;
    private $dtEnvio;
    private $dtResposta;
    private $idOperacao;
    private $nrRecibo;
    private $dsDirArqXml;
    private $dsArqXml;
    private $nrorg;

    public function __construct($dsEvento, $versao, $nrChave, $dtMesCompetenc, $nrorg)
    {
        $this->nrEnvio        = null;
        $this->nrEsocial      = self::getNrEsocial($dsEvento, $versao);
        $this->dsEvento       = $dsEvento;
        $this->versao         = $versao;
        $this->nrChave        = $nrChave;
        $this->dtMescompetenc = $dtMesCompetenc;
        $this->dtEnvio        = null;
        $this->dtResposta     = null;
        $this->idOperacao     = null;
        $this->nrRecibo       = null;
        $this->dsDirArqXml    = null;
        $this->dsArqXml       = null;
        $this->nrorg          = $nrorg;
    }

    private function getNrEsocial($dsEvento, $versao)
    {
        $gpeEsocial = GpeEsocial::findOneByNomeAndVersao($dsEvento, $versao);

        if (is_object($gpeEsocial)) {
            return $gpeEsocial->getNresocial();
        } else {
            throw new \Exception("Erro ao gerar log de envio [Versão $versao do evento $dsEvento não encontrada]");
        }
    }

    /**
     * Função criada somente para que seja verificado se é o primeiro envio, Inclusão, ou se o arquivo já foi enviado e
     * trata-se de uma alteração. É retornado para o dataSource do evento um array com os valores de inclusão e alteração.
     *
     * @return array
     */
    public function validaTipoEnvio()
    {
        $envio = GpeEsocialEnvio::findByNresocialAndNrchaveAndNrorg($this->nrEsocial, $this->nrChave, $this->nrorg);

        $inclusao = 0;
        $alteracao = 0;

        if ($envio == null) {
            $inclusao = 1;
        }
        else {
            $alteracao = 1;
        }

        return array(
                    'INCLUSAO' => $inclusao,
                    'ALTERACAO' => $alteracao,
                    );
    }

    public function verificaEnvio()
    {
        $envio = GpeEsocialEnvio::findByNresocialAndNrchaveAndNrorg($this->nrEsocial, $this->nrChave, $this->nrorg);

        $this->nrEnvio = \Geral\Util\NovoCodigo::geraCodigo($this->nrorg, 'GPE_ESOCIAL_ENVIO');

        if ($envio == null) {
            $this->idOperacao = 'I';
        }
        else {
            $this->idOperacao = 'U';
        }
    }

    public function setXml($arquivo, $diretorio)
    {
        $this->dsDirArqXml = $diretorio;
        $this->dsArqXml = $arquivo;
    }

    public function persisteEnvio()
    {
        try {
            $dataAtual = \HCM\Util\DateUtil::getDataAtual();
            $operador = \Geral\Util\Ambiente::getCdOperador();
            $dtMescompetenc = \HCM\Util\DateUtil::getDataDeString($this->dtMescompetenc);

            $gpeEnvio = new GpeEsocialEnvio();

            $gpeEnvio->setNrenvio($this->nrEnvio);
            $gpeEnvio->setNresocial($this->nrEsocial);
            $gpeEnvio->setDsevento($this->dsEvento);
            $gpeEnvio->setNrchave($this->nrChave);
            $gpeEnvio->setDtmescompetenc($dtMescompetenc);
            $gpeEnvio->setDtenvio($dataAtual);
            $gpeEnvio->setDtresposta($this->dtResposta);
            $gpeEnvio->setNrorg($this->nrorg);
            $gpeEnvio->setIdoperacao($this->idOperacao);
            $gpeEnvio->setNrrecibo($this->nrRecibo);
            $gpeEnvio->setDsdirarqxml($this->dsDirArqXml);
            $gpeEnvio->setDsarqxml($this->dsArqXml);
            $gpeEnvio->setIdativo('S');
            $gpeEnvio->setDtinclusao($dataAtual);
            $gpeEnvio->setCdoperinclusao($operador);
            $gpeEnvio->setNrorginclusao($this->nrorg);

            $gpeEnvio->persist();

            \Setforms2\Shared\Registry::getEntityManager()->flush();
        } catch (\Exception $e) {
            throw $e;
        }
    }
}